/*
     GDIrbg}bviDDBj쐬

        2005/ 2/24 ˁ@P
*/
#include <windows.h>

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

HWND g_hwMain;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) {

	MSG msg;
	WNDCLASSEX wndclass;
	
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "DDBTest";
	wndclass.hIconSm       = NULL;
	RegisterClassEx(&wndclass);

	g_hwMain = CreateWindow ("DDBTest", "DDB쐬", WS_OVERLAPPEDWINDOW,
	  CW_USEDEFAULT, CW_USEDEFAULT, 300, 320, 
	  NULL, NULL, hInstance, NULL);

	ShowWindow (g_hwMain, iCmdShow);

	while (GetMessage(&msg, NULL, 0, 0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return (int)msg.wParam;

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;

	static HBITMAP hbmpTest, hbmpTestOld;
	static HDC hdcTest;

	int i, j;

	switch (iMsg) {

	case WM_CREATE:

		/* EChEHDC擾 */
		hdc = GetDC(hwnd);

		/* EChEHDCƌ݊̂DDB쐬 */
		hbmpTest = CreateCompatibleBitmap(hdc, 256, 256);

		/* EChEHDCƌ݊̂foCXReLXg쐬 */
		hdcTest = CreateCompatibleDC(hdc);

		/* EChEHDC */
		ReleaseDC(hwnd, hdc);

		/* DDBfoCXReLXgɑI */
		hbmpTestOld = (HBITMAP)SelectObject(hdcTest, hbmpTest);

		/* DDBɃOf[V` */
		for (i = 0;i < 256;i++) {
			for (j = 0;j < 256;j++) {
				SetPixel(hdcTest, j, i, RGB(128, j, i));
			}
		}

		return 0;

	case WM_PAINT:

		hdc = BeginPaint(hwnd,&ps);

		/* DDBEChEɕ` */
		BitBlt(hdc, 0, 0, 256, 256, hdcTest, 0, 0, SRCCOPY);

		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY : /* I */

		/* DDB̑IԂ */
		SelectObject(hdcTest, hbmpTestOld);

		/* foCXReLXg폜 */
		DeleteDC(hdcTest);

		/* DDB폜 */
		DeleteObject(hbmpTest);

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam) ;

}
